/* Inclut la librairie Servo pour manipuler le servomoteur
Soit :
 2 joysticks 2 axes(recupe) + 1 joystick 1 axe crecupe telecommande voiture)
 3 boutons ,button1 mise en memoire , button2 depart memoire ,button3 commande de la pince
 5 LEDS visualisation des 5 positions en memoire

*/

#include <Servo.h>
/* Créer un objet Servo pour contrôler le servomoteur */
Servo  servo1;  // base pivotante  bras
Servo servo2;   // premier pivot  bras
Servo servo3;   // deuxieme pivot bras ( coude)
Servo servo4;   // rotation poignet
Servo servo5;   // troisieme pivot  (poignet)
Servo servo6;   // pince

int angle_mini = 250;  //en microseconde  (0 en degres)
int angle_maxi = 5000; //en microseconde  (180 en degres)
int Tempo = 1;         //timmer joue donc sur la viesse (0 a  ?)

int servo1position ; 
int servo2position;
int servo3position;
int servo4position;
int servo5position;

const int LED1 = 2; //LEDs
const int LED2 = 3;
const int LED3 = 4;
const int LED4 = 7;
const int LED5 = 8;

const int button1 = 12; //Buttons
const int button2 = 13;

int button1Presses = 0;
boolean button2Pressed = false;

int vitesse =0 ;

const int pot1 = A0;  // axe X1 joystick  ,base pivotante  bras
const int pot2 = A1; // axe Y1  joystick  , premier pivot  bras
const int pot3 = A2;  //axe Y2 joystick   , deuxieme pivot bras ( coude)
const int pot4 = A3;  //axe X2 joystick, rotation poignet
const int pot5 = A4;  //axe Z2 joystick , troisieme pivot  (poignet)
const int button3 = A5;   //  pince

int pot1Val;  // valeure analogique lue
int pot2Val;
int pot3Val;
int pot4Val;
int pot5Val;

int pot1Angle;  // mapping potval en position en microseconde
int pot2Angle;
int pot3Angle;
int pot4Angle;
int pot5Angle;
int positionDuservo6 = 0 ;//

int servo1PosSaves[] = {1,1,1,1,1}; //position saves
int servo2PosSaves[] = {1,1,1,1,1};
int servo3PosSaves[] = {1,1,1,1,1};
int servo4PosSaves[] = {1,1,1,1,1};
int servo5PosSaves[] = {1,1,1,1,1};
int servo6PosSaves[] = {1,1,1,1,1};


void setup()
{
 
Serial.begin(9600);
  Serial.print("servomot joy by me v4 micosec: "); 
  
  servo1.attach(5);      // Attache le servomoteur au 5
  servo2.attach(6);    // Attache le servomoteur au 6
  servo3.attach(9); // Attache le servomoteur au 9
  servo4.attach(10); // Attache le servomoteur au 10
  servo5.attach(11); // Attache le servomoteur au 11
  servo6.attach(3); // Attache le servomoteur au 3
  
   servo1position =  servo1.read(); //pour permettre d'être à l'arrêt initialement
   servo2position =  servo2.read();
   servo3position =  servo3.read();
   servo4position =  servo4.read();
   servo5position =  servo5.read();
   servo6.write(positionDuservo6) ;
   
  Serial.begin(9600);  

  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  pinMode(LED5, OUTPUT);
  
  pinMode(button1, INPUT);
  pinMode(button2, INPUT);
  pinMode(button3, INPUT);
}

void loop()
{                  //joystick X1
 pot1Val = analogRead(pot1);
    pot1Angle = map(pot1Val, 0, 1023,angle_mini , angle_maxi);
   if (pot1Val > 612) {
      servo1position = servo1position+ 3;//+1 reglage pas donc +ou- vitesse et precision
   if ( servo1position > angle_maxi) {
       servo1position = angle_maxi; // limitation angle maxi     
    }
        servo1.writeMicroseconds(  servo1position/2);
        delay(Tempo);    
  }
   if (pot1Val < 412){
      servo1position = servo1position - 3;//-1 reglage pas donc +ou- vitesse et precision
   if ( servo1position < angle_mini) { //limitation angle mini
      servo1position = angle_mini;     
    }
       servo1.writeMicroseconds( servo1position/2);
       delay(Tempo);   
  }


                 //joystick Y1
 pot2Val = analogRead(pot2);
    pot2Angle = map(pot2Val, 0, 1023,angle_mini , angle_maxi);
   if (pot2Val > 612) {
      servo2position = servo2position + 3;//+1 reglage pas donc +ou- vitesse et precision
   if (servo2position > angle_maxi) {
      servo2position = angle_maxi; // limitation angle maxi     
    }
        servo2.writeMicroseconds(servo2position/2);
        delay(Tempo);    
  }
   if (pot2Val < 412){
      servo2position = servo2position - 3;//-1 reglage pas donc +ou- vitesse et precision
   if (servo2position < angle_mini) { //limitation angle mini
      servo2position = angle_mini;     
    }
       servo2.writeMicroseconds(servo2position/2);
       delay(Tempo);   
  }

                //joystick Y2
 pot3Val = analogRead(pot3);
    pot3Angle = map(pot3Val, 0, 1023,angle_mini , angle_maxi);
   if (pot3Val > 612) {
      servo3position = servo3position + 3;//+1 reglage pas donc +ou- vitesse et precision
   if (servo3position > angle_maxi) {
      servo3position = angle_maxi; // limitation angle maxi     
    }
        servo3.writeMicroseconds(servo3position/2);
        delay(Tempo);    
  }
   if (pot3Val < 412){
      servo3position = servo3position - 3;//-1 reglage pas donc +ou- vitesse et precision
   if (servo3position < angle_mini) { //limitation angle mini
      servo3position = angle_mini;     
    }
       servo3.writeMicroseconds(servo3position/2);
       delay(Tempo);   
  }

                //joystick X2
 pot4Val = analogRead(pot4);
    pot4Angle = map(pot4Val, 0, 1023,angle_mini , angle_maxi);
   if (pot4Val > 612) {
      servo4position = servo4position + 3;//+1 reglage pas donc +ou- vitesse et precision
   if (servo4position > angle_maxi) {
      servo4position = angle_maxi; // limitation angle maxi     
    }
        servo4.writeMicroseconds(servo4position/2);
        delay(Tempo);    
  }
   if (pot4Val < 412){
      servo4position = servo4position - 3;//-1 reglage pas donc +ou- vitesse et precision
   if (servo4position < angle_mini) { //limitation angle mini
     servo4position = angle_mini;     
    }
       servo4.writeMicroseconds(servo4position/2);
       delay(Tempo);   
  }

               //joystick Z2
 pot5Val = analogRead(pot5);
    pot5Angle = map(pot5Val, 0, 1023,angle_mini , angle_maxi);
   if (pot5Val > 612) {
      servo5position =  servo5position + 3;//+1 reglage pas donc +ou- vitesse et precision
   if ( servo5position > angle_maxi) {
       servo5position = angle_maxi; // limitation angle maxi     
    }
        servo5.writeMicroseconds( servo5position/2);
        delay(Tempo);    
  }
   if (pot5Val < 412){
       servo5position =  servo5position - 3;//-1 reglage pas donc +ou- vitesse et precision
   if ( servo5position < angle_mini) { //limitation angle mini
       servo5position = angle_mini;     
    }
       servo5.writeMicroseconds( servo5position/2);
       delay(Tempo);   
  }

             // PINCE   
 servo6.write(positionDuservo6) ;
 if (analogRead(button3) <1) {
     Serial.println(button3); 
   //if(digitalRead(button3) == HIGH){
 positionDuservo6 = 100;
 // positionDuservo <=180; positionDuservo++ ;//for
   Serial.println(positionDuservo6);
  servo6.write(positionDuservo6);
  //servo5.write(180) ;
  delay(600) ;  
  }
 else

{
  positionDuservo6 =0 ;// positionDuservo >=0; positionDuservo--) //for
//{
  servo6.write(positionDuservo6);
 // delay(15) ; 
}


   
if(digitalRead(button1) == HIGH){ // This will check how many times button1 is pressed and save the positions to an array depending on how many times it is pressed; switch/case works like a if statement  
   button1Presses++;
   
    switch( button1Presses ){
      case 1: 
             
        servo1PosSaves[0] = servo1position/2 ;
         servo2PosSaves[0] =  servo2position/2;
        servo3PosSaves[0] =  servo3position/2;
        servo4PosSaves[0] = servo4position/2;
         servo5PosSaves[0] = servo5position/2;
         servo6PosSaves[0] = positionDuservo6;
        digitalWrite(LED1, HIGH);
        Serial.println("Pos 1 Saved");
        delay(300);
        break;
      case 2:
           
         servo1PosSaves[1] = servo1position/2 ;
         servo2PosSaves[1] =  servo2position/2;          
         servo3PosSaves[1] = servo3position/2;
         servo4PosSaves[1] = servo4position/2;
          servo5PosSaves[1] = servo5position/2;
         servo6PosSaves[1] = positionDuservo6;
         digitalWrite(LED2, HIGH);
         Serial.println("Pos 2 Saved");
         delay(300);
         break;
      case 3:
        
        
         servo1PosSaves[2] = servo1position/2 ;
         servo2PosSaves[2] =  servo2position/2;
         servo3PosSaves[2] = servo3position/2;
         servo4PosSaves[2] = servo4position/2;
         servo5PosSaves[2] = servo5position/2;
          servo6PosSaves[2] = positionDuservo6;
         digitalWrite(LED3, HIGH);
         Serial.println("Pos 3 Saved");
         delay(300);
         break;
       case 4:
      
         servo1PosSaves[3] = servo1position/2 ;
         servo2PosSaves[3] =  servo2position/2;
         servo3PosSaves[3] = servo3position/2;
         servo4PosSaves[3] = servo4position/2;
          servo5PosSaves[3] = servo5position/2;
           servo6PosSaves[3] = positionDuservo6;
         digitalWrite(LED4, HIGH);
         Serial.println("Pos 4 Saved");
         delay(300);
         break;
       case 5:
         
         servo1PosSaves[4] = servo1position/2 ;
         servo2PosSaves[4] =  servo2position/2;
         servo3PosSaves[4] = servo3position/2;
         servo4PosSaves[4] = servo4position/2;
          servo5PosSaves[4] = servo5position/2;
         servo6PosSaves[4] = positionDuservo6;
         digitalWrite(LED5, HIGH);
         Serial.println("Pos 5 Saved");
         delay(300);
         break;
    }
  
}////////
 if(digitalRead(button2) == HIGH){ // Pretty self-explnatory here
    button2Pressed = true;   
  }
  
  if(button2Pressed){ // if the boolean button2Press is true, then the servos will run though all their saved positions
 //delay(Tempo2);
     for(int i = 0; i < 5; i++){
     
       servo1.writeMicroseconds(servo1PosSaves[i]);  
        servo2.writeMicroseconds(servo2PosSaves[i]);
        servo3.writeMicroseconds(servo3PosSaves[i]);
        servo4.writeMicroseconds(servo4PosSaves[i]);
            servo5.writeMicroseconds(servo5PosSaves[i]);
            servo6.writeMicroseconds(servo6PosSaves[i]);
           
       // Serial.println(" potentimeter Angles: ");
       // Serial.println(servo1PosSaves[i]);
       // Serial.println(servo2PosSaves[i]);        
     //   Serial.println(servo3PosSaves[i]); 
      //  Serial.println(servo4PosSaves[i]);
         //  Serial.println(servo5PosSaves[i]);
        delay(1050);//  lolo
      
      }
  }

  } 



